--- simple initializer for singletons
-- 
-- @file	rawInterfaces.lua 
-- @author	Pavel Yadvichuk
-- @created 2015/05/23

--- @module rawInterfaces
local rawInterfaces = {} 

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
function rawInterfaces:initializeSingletons(cfg)
	require"astDbRawInterface":getInstance(cfg["ast"].prefix)
	require"sqliteRawInterface":getInstance(cfg["hotel"].file)
	
	local memcCfg = cfg["mem"] or nil
	if "memc_simple" == memcCfg.ident then
		require"memcSimpleRawInterface":getInstance(cfg["mem"].options)
	elseif "memc" == memcCfg.ident then
		require"memcRawInterface":getInstance(cfg["mem"].options)
	end
end

return rawInterfaces
