--- instantiate various types of accessors
-- 
-- @file	AccessorFactory.lua 
-- @author	Pavel Yadvichuk
-- @created 2015/04/06

--- @module AccessorFactory
local AccessorFactory = {} 

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
local factory = { configs={} }

function factory:instantiate(ident)
	if ident == "mem" then
		return require"MemAccessor":new(self.configs[ident])
	elseif ident == "hotel" then
		return require"HotelAccessor":new(self.configs[ident])
	elseif ident == "ast" then
		return require"AstAccessor":new(self.configs[ident])
	end
	return nil
end


function AccessorFactory:new(cfg)
	local obj = {}
	setmetatable(obj, {__index = factory})
	obj.configs = cfg
	return obj
end

return AccessorFactory