--- 
-- 
-- @file	AstAccessor.lua 
-- @author	Pavel Yadvichuk
-- @created 2015/04/07

--- @module AstAccessor
local AstAccessor = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
local accessor = require"IAccessor":new()        -- meta class

--- @see description in IAccessor
function accessor:put(key, val)
	return self.driver:put(key, val)
end

--- @see description in IAccessor
function accessor:get(key)
	return self.driver:get(key)
end

--- @see description in IAccessor
function accessor:del(key)
	if "table" == type(key) and "tree" == key.ident then
		self.driver:delTree(key.val)
	else
		self.driver:del(key)
	end
end


--- Constructor
function AstAccessor:new(cfg)
	local err = nil
	local obj = {}
	setmetatable(obj, {__index = accessor})

	if "table" == type(cfg) then
		obj.driver = require"astDriver":new(cfg)
		if not obj.driver then
			return false, err
		end
	end

	return obj
end

return AstAccessor