--- factory for concrete drivers implementations
-- 
-- @file	DriversFactory.lua 
-- @author	Pavel Yadvichuk
-- @created 2015/04/07

--- @module DriversFactory
local DriversFactory = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
local factory = { config = {} }

function factory:instantiate(ident)
	if ident == "memc" then
		return require"memcDriver":new(self.config)
	elseif ident == "sqlite" then
		return require"sqliteDriver":new(self.config)
	elseif ident == "memc_simple" then
		return require"memcSimpleDriver":new(self.config)
	end
	return nil
end


function DriversFactory:new(cfg)
	local obj = {}
	setmetatable(obj, {__index = factory})
	obj.config = cfg
	return obj
end

return DriversFactory
