--- memcache driver
-- 
-- @file	memcDriver.lua 
-- @author	Pavel Yadvichuk
-- @created 2015/04/07

--- @module memcDriver
local memcDriver = {}

----------------------------------------------------------------
-- Public interface
----------------------------------------------------------------
local driver = require"IDriver":new()        -- meta class
driver.cfg   = {
	host = nil,		-- memcached host data
	port = nil,		-- memcached port value
}

--- @see description in IDriver
function driver:put(key, val)
	return self.raw.request(self.cfg,{act = "PUT", key = key, val = val})
end

--- @see description in IDriver
function driver:get(key)
	return self.raw.request(self.cfg,{act = "GET", key = key})
end

--- @see description in IDriver
function driver:del(key)
	return self.raw.request(self.cfg,{act = "DEL", key = key})
end


--- Constructor
function memcDriver:new(cfg)
	if "table" ~= type(cfg) then
		return false, "Memc: configuration not found"
	end
	if not cfg.host or "" == cfg.host then
		return false, "Memc: invalid host data in config"
	end
	cfg.port = tonumber(cfg.port)
	if not cfg.port then
		return false, "Memc: invalid port in config"
	end
	
	
	local obj = {}
	setmetatable(obj, {__index = driver})
	
	-- init configuration	
	obj.cfg = cfg
	obj.raw = require("memcRawInterface"):getInstance()
	
	return obj
end

return memcDriver
