--- simple FIFO implementation
-- 
-- @file	fifo.lua 
-- @author	Pavel Yadvichuk
-- @created 2015/05/18

--- @module fifo
local fifo = {}

----------------------------------------------------------------
-- public interface
----------------------------------------------------------------
local Fifo = { _queue={} }

--- Pushes a value at the tail of the heap
-- @param v			value to insert into
function Fifo:push(v)
	table.insert(self._queue, v)
end

--- Remove and return the value at the head of the heap
-- @return item from the head of fifo
-- @note item will be removed from fifo
function Fifo:pop()
  local head = self._queue[1]
  table.remove(self._queue, 1)
  return head
end

--- Clears the heap
function Fifo:clear()
	self._queue = {}
end

--- Checks if the heap is empty
function Fifo:isEmpty()
	return #self._queue == 0
end


--- Constructor
function fifo:new()
	local obj = {}
	setmetatable(obj, {__index = Fifo})
	return obj
end

return fifo

