--- makes modules read-only 
-- 
-- @file    locker.lua 
-- @author  Pavel Yadvichuk
-- @created 2015/04/08

local glob = _G
 
module('locker')

function lock(module)
	local t = {}

	for k, v in glob.pairs(module) do
		t[k] = v
		glob.rawset(module, k, nil)
	end
	glob.rawset(module, 'privateData_', t)

	local meta = {
 					__index = function(t, k)
								return t.privateData_[k]
 							  end,
					__newindex = function(t, k, v)
									glob.error('access denied!')
 							  end, 
 	}
	glob.setmetatable(module, meta)
end