--- Helper module to handle timer values 
--  of the system periodic messages
-- 
-- @file    timerHelper.lua 
-- @author  Vyacheslav Khudan
-- @created 2018/17/11

--@module timerHelper
local timerHelper = {}

-- the default value retrieved from source code of manager implementation
local SECONDS_PER_SYSTEMTICK = 3    -- one tick in <NUM> seconds

--- Convert to user time in seconds to system periodic ticks
-- @param userValueSec A required user value of seconds
-- @param systemTick   A value in seconds for one system tick
-- @return system ticks number equivalent to required user value  
function timerHelper.fromTimeCounter(userValueSec, systemTick)
    systemTick = systemTick or SECONDS_PER_SYSTEMTICK
    
    return userValueSec / systemTick    
end

return timerHelper